using System;
using System.Threading;

namespace FileMultiplikator
{
	/// <summary>
	/// Summary description for ThreadSafeCounter.
	/// </summary>
	public class ThreadSafeCounter
	{
		private int count=0;
		public int Count
		{
			get {return count;}
		}

		private System.DateTime started=DateTime.Now;

		public int Increment()
		{
			Interlocked.Increment(ref count);
			if(count%100==0)
			{
				double seconds=DateTime.Now.Subtract(started).TotalSeconds;
				Console.WriteLine("{0} requests in {1:0.00} seconds, ie. {2:0.00} Requests/sec",count,seconds,count/seconds);
			}
			return count;
		}
	}
}
