using System;
using System.Threading;
using System.Data.SqlClient;

namespace WSClientStress
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			Console.WriteLine("Deleting BrozuraCRM data ...");
			VymazDatabaziBrozuraCRM();
			Console.WriteLine("Deleted BrozuraCRM data ...");

			Console.WriteLine("Generating 1000 category X records in CRM ...");
			for(int i=1;i<=1000;i++)
				GenerujCRMRecord(i,"X");
			Console.WriteLine("Generated 1000 category X records in CRM...");

			Console.WriteLine("Generating 1000 category A records in CRM ...");
			for(int i=1001;i<=2000;i++)
				GenerujCRMRecord(i,"A");
			Console.WriteLine("Generated 1000 category A records in CRM...");

			int nPocetZadosti=int.Parse(System.Configuration.ConfigurationSettings.AppSettings["Pocet"]);
			ThreadSafeCounter c=new ThreadSafeCounter();
			for(int i=0;i<nPocetZadosti/3;i++)
			{
				Worker w1=new Worker(TypPrubehuZadosti.AutomatickySchvalena);
				ThreadPool.QueueUserWorkItem(new WaitCallback(w1.DoWork),c);
				Worker w2=new Worker(TypPrubehuZadosti.AutomatickyZamitnuta);
				ThreadPool.QueueUserWorkItem(new WaitCallback(w2.DoWork),c);
				Worker w3=new Worker(TypPrubehuZadosti.ManualniRozhodnuti);
				ThreadPool.QueueUserWorkItem(new WaitCallback(w3.DoWork),c);
			}
			Console.WriteLine("Press Enter to Exit");
			Console.ReadLine();
		}

		static void VymazDatabaziBrozuraCRM()
		{
			string cs="Data Source=(local);Integrated Security=SSPI;Initial Catalog=BrozuraCRM";
			SqlConnection conn=new SqlConnection(cs);
			SqlCommand cmd=new SqlCommand("DELETE FROM tblOsoby",conn);
			conn.Open();
			cmd.ExecuteNonQuery();
			conn.Close();
		}

		static void GenerujCRMRecord(int cislo, string kategorie)
		{
			CRM.KontaktniUdaje ku=new CRM.KontaktniUdaje();
			ku.CasovaZnamka=DateTime.Now;
			ku.Jmeno=new CRM.KontaktniUdajeJmeno();
			ku.Jmeno.Krestni="Krestni";
			ku.Jmeno.Prijmeni="Prijmeni";
			ku.Kategorie=kategorie;
			string s="0000000000"+cislo.ToString();
			ku.RodneCislo=s.Substring(s.Length-10);
			ku.Telefony=new CRM.KontaktniUdajeTelefon[2];
			ku.Telefony[0]=new CRM.KontaktniUdajeTelefon();
			ku.Telefony[0].Typ="Typ0";
			ku.Telefony[0].Predvolba="123";
			ku.Telefony[0].Cislo="123456789";
			ku.Telefony[1]=new CRM.KontaktniUdajeTelefon();
			ku.Telefony[1].Typ="Typ1";
			ku.Telefony[1].Predvolba="123";
			ku.Telefony[1].Cislo="123456789";

			new CRM.KontaktniUdajeSluzba().ZadejKontaktniUdaje(ku);
		}
	}
}
